|
|||||||||
| Home >> All >> org >> mortbay >> jetty >> [ servlet overview ] | PREV CLASS NEXT CLASS | ||||||||
SUMMARY: JAVADOC | SOURCE | DOWNLOAD | NESTED | FIELD | CONSTR | METHOD |
DETAIL: FIELD | CONSTR | METHOD | ||||||||
org.mortbay.jetty.servlet
Class ServletHttpResponse

java.lang.Objectorg.mortbay.jetty.servlet.ServletHttpResponse
- All Implemented Interfaces:
- javax.servlet.http.HttpServletResponse, javax.servlet.ServletResponse
- public class ServletHttpResponse
- extends java.lang.Object
- implements javax.servlet.http.HttpServletResponse
- extends java.lang.Object
Servlet Response Wrapper. This class wraps a Jetty HTTP response as a 2.2 Servlet response. Note that this wrapper is not synchronized and if a response is to be operated on by multiple threads, then higher level synchronizations may be required.
- Version:
- $Id: ServletHttpResponse.java,v 1.43 2003/10/05 23:46:28 gregwilkins Exp $
| Field Summary | |
private static ServletOut |
__nullServletOut
|
private static ServletWriter |
__nullServletWriter
|
private org.mortbay.http.HttpResponse |
_httpResponse
|
private java.util.Locale |
_locale
|
private boolean |
_noSession
|
private ServletOut |
_out
|
private int |
_outputState
|
private ServletHttpRequest |
_servletHttpRequest
|
private javax.servlet.http.HttpSession |
_session
|
private ServletWriter |
_writer
|
static int |
DISABLED
|
private static org.apache.commons.logging.Log |
log
|
static int |
NO_OUT
|
static int |
OUTPUTSTREAM_OUT
|
static int |
WRITER_OUT
|
| Constructor Summary | |
(package private) |
ServletHttpResponse(ServletHttpRequest request,
org.mortbay.http.HttpResponse response)
|
| Method Summary | |
void |
addCookie(javax.servlet.http.Cookie cookie)
Adds the specified cookie to the response. |
void |
addDateHeader(java.lang.String name,
long value)
Adds a response header with the given name and date-value. |
void |
addHeader(java.lang.String name,
java.lang.String value)
Adds a response header with the given name and value. |
void |
addIntHeader(java.lang.String name,
int value)
Adds a response header with the given name and integer value. |
(package private) void |
commit()
|
boolean |
containsHeader(java.lang.String name)
Returns a boolean indicating whether the named response header has already been set. |
java.lang.String |
encodeRedirectUrl(java.lang.String url)
Deprecated. As of version 2.1, use encodeRedirectURL(String url) instead |
java.lang.String |
encodeRedirectURL(java.lang.String url)
Encodes the specified URL for use in the sendRedirect method or, if encoding is not needed,
returns the URL unchanged. |
java.lang.String |
encodeUrl(java.lang.String url)
Deprecated. As of version 2.1, use encodeURL(String url) instead |
java.lang.String |
encodeURL(java.lang.String url)
Encodes the specified URL by including the session ID in it, or, if encoding is not needed, returns the URL unchanged. |
void |
flushBuffer()
Forces any content in the buffer to be written to the client. |
int |
getBufferSize()
Returns the actual buffer size used for the response. |
java.lang.String |
getCharacterEncoding()
Returns the name of the character encoding (MIME charset) used for the body sent in this response. |
java.lang.String |
getContentType()
Returns the content type used for the MIME body sent in this response. |
(package private) org.mortbay.http.HttpResponse |
getHttpResponse()
|
java.util.Locale |
getLocale()
Returns the locale specified for this response using the setLocale(java.util.Locale) 55 method. |
(package private) int |
getOutputState()
|
javax.servlet.ServletOutputStream |
getOutputStream()
Returns a javax.servlet.ServletOutputStream suitable for writing binary data in the response. |
java.io.PrintWriter |
getWriter()
Returns a PrintWriter object that
can send character text to the client. |
boolean |
isCommitted()
Returns a boolean indicating if the response has been committed. |
(package private) boolean |
isDirty()
|
(package private) void |
recycle()
|
void |
reset()
Clears any data that exists in the buffer as well as the status code and headers. |
void |
resetBuffer()
Clears the content of the underlying buffer in the response without clearing headers or status code. |
void |
sendError(int status)
Sends an error response to the client using the specified status code and clearing the buffer. |
void |
sendError(int status,
java.lang.String message)
Sends an error response to the client using the specified status. |
void |
sendRedirect(java.lang.String url)
Sends a temporary redirect response to the client using the specified redirect location URL. |
void |
setBufferSize(int size)
Sets the preferred buffer size for the body of the response. |
void |
setCharacterEncoding(java.lang.String encoding)
Sets the character encoding (MIME charset) of the response being sent to the client, for example, to UTF-8. |
void |
setContentLength(int len)
Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header. |
void |
setContentType(java.lang.String contentType)
Sets the content type of the response being sent to the client, if the response has not been committed yet. |
void |
setDateHeader(java.lang.String name,
long value)
Sets a response header with the given name and date-value. |
void |
setHeader(java.lang.String name,
java.lang.String value)
Sets a response header with the given name and value. |
void |
setIntHeader(java.lang.String name,
int value)
Sets a response header with the given name and integer value. |
void |
setLocale(java.util.Locale locale)
Sets the locale of the response, setting the headers (including the Content-Type's charset) as appropriate. |
(package private) void |
setOutputState(int s)
|
void |
setStatus(int status)
Sets the status code for this response. |
void |
setStatus(int status,
java.lang.String message)
Deprecated. As of version 2.1 of the Servlet spec. To set a status code use setStatus(int), to send an error with a description
use sendError(int, String).
Sets the status code and message for this response. |
java.lang.String |
toString()
Convert this Object to a human-readable String. |
static ServletHttpResponse |
unwrap(javax.servlet.ServletResponse response)
Unwrap a ServletResponse. |
| Methods inherited from class java.lang.Object |
clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait |
| Field Detail |
log
private static org.apache.commons.logging.Log log
DISABLED
public static final int DISABLED
- See Also:
- Constant Field Values
NO_OUT
public static final int NO_OUT
- See Also:
- Constant Field Values
OUTPUTSTREAM_OUT
public static final int OUTPUTSTREAM_OUT
- See Also:
- Constant Field Values
WRITER_OUT
public static final int WRITER_OUT
- See Also:
- Constant Field Values
__nullServletWriter
private static ServletWriter __nullServletWriter
__nullServletOut
private static ServletOut __nullServletOut
_httpResponse
private org.mortbay.http.HttpResponse _httpResponse
_servletHttpRequest
private ServletHttpRequest _servletHttpRequest
_outputState
private int _outputState
_out
private ServletOut _out
_writer
private ServletWriter _writer
_session
private javax.servlet.http.HttpSession _session
_noSession
private boolean _noSession
_locale
private java.util.Locale _locale
| Constructor Detail |
ServletHttpResponse
ServletHttpResponse(ServletHttpRequest request, org.mortbay.http.HttpResponse response)
| Method Detail |
recycle
void recycle()
getOutputState
int getOutputState()
setOutputState
void setOutputState(int s)
throws java.io.IOException
getHttpResponse
org.mortbay.http.HttpResponse getHttpResponse()
commit
void commit()
throws java.io.IOException
isCommitted
public boolean isCommitted()
- Description copied from interface:
javax.servlet.ServletResponse - Returns a boolean indicating if the response has been
committed. A committed response has already had its status
code and headers written.
- Specified by:
isCommittedin interfacejavax.servlet.ServletResponse
isDirty
boolean isDirty()
setBufferSize
public void setBufferSize(int size)
- Description copied from interface:
javax.servlet.ServletResponse - Sets the preferred buffer size for the body of the response.
The servlet container will use a buffer at least as large as
the size requested. The actual buffer size used can be found
using
getBufferSize.A larger buffer allows more content to be written before anything is actually sent, thus providing the servlet with more time to set appropriate status codes and headers. A smaller buffer decreases server memory load and allows the client to start receiving data more quickly.
This method must be called before any response body content is written; if content has been written or the response object has been committed, this method throws an
IllegalStateException.- Specified by:
setBufferSizein interfacejavax.servlet.ServletResponse
getBufferSize
public int getBufferSize()
- Description copied from interface:
javax.servlet.ServletResponse - Returns the actual buffer size used for the response. If no buffering
is used, this method returns 0.
- Specified by:
getBufferSizein interfacejavax.servlet.ServletResponse
flushBuffer
public void flushBuffer()
throws java.io.IOException
- Description copied from interface:
javax.servlet.ServletResponse - Forces any content in the buffer to be written to the client. A call
to this method automatically commits the response, meaning the status
code and headers will be written.
- Specified by:
flushBufferin interfacejavax.servlet.ServletResponse
resetBuffer
public void resetBuffer()
- Description copied from interface:
javax.servlet.ServletResponse - Clears the content of the underlying buffer in the response without
clearing headers or status code. If the
response has been committed, this method throws an
IllegalStateException.- Specified by:
resetBufferin interfacejavax.servlet.ServletResponse
reset
public void reset()
- Description copied from interface:
javax.servlet.ServletResponse - Clears any data that exists in the buffer as well as the status code and
headers. If the response has been committed, this method throws an
IllegalStateException.- Specified by:
resetin interfacejavax.servlet.ServletResponse
setLocale
public void setLocale(java.util.Locale locale)
- Sets the locale of the response, setting the headers (including the
Content-Type's charset) as appropriate. This method should be called
before a call to
getWriter()55 . By default, the response locale is the default locale for the server.- Specified by:
setLocalein interfacejavax.servlet.ServletResponse
getLocale
public java.util.Locale getLocale()
- Description copied from interface:
javax.servlet.ServletResponse - Returns the locale specified for this response
using the ServletResponse.setLocale(java.util.Locale)>
ServletResponse.setLocale(java.util.Locale)55 method. Calls made tosetLocaleafter the response is committed have no effect. If no locale has been specified, the container's default locale is returned.- Specified by:
getLocalein interfacejavax.servlet.ServletResponse
addCookie
public void addCookie(javax.servlet.http.Cookie cookie)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Adds the specified cookie to the response. This method can be called
multiple times to set more than one cookie.
- Specified by:
addCookiein interfacejavax.servlet.http.HttpServletResponse
containsHeader
public boolean containsHeader(java.lang.String name)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Returns a boolean indicating whether the named response header
has already been set.
- Specified by:
containsHeaderin interfacejavax.servlet.http.HttpServletResponse
encodeURL
public java.lang.String encodeURL(java.lang.String url)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Encodes the specified URL by including the session ID in it,
or, if encoding is not needed, returns the URL unchanged.
The implementation of this method includes the logic to
determine whether the session ID needs to be encoded in the URL.
For example, if the browser supports cookies, or session
tracking is turned off, URL encoding is unnecessary.
For robust session tracking, all URLs emitted by a servlet should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.
- Specified by:
encodeURLin interfacejavax.servlet.http.HttpServletResponse
encodeRedirectURL
public java.lang.String encodeRedirectURL(java.lang.String url)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Encodes the specified URL for use in the
sendRedirectmethod or, if encoding is not needed, returns the URL unchanged. The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL. Because the rules for making this determination can differ from those used to decide whether to encode a normal link, this method is separated from theencodeURLmethod.All URLs sent to the
HttpServletResponse.sendRedirectmethod should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies.- Specified by:
encodeRedirectURLin interfacejavax.servlet.http.HttpServletResponse
encodeUrl
public java.lang.String encodeUrl(java.lang.String url)
- Deprecated. As of version 2.1, use encodeURL(String url) instead
- Specified by:
encodeUrlin interfacejavax.servlet.http.HttpServletResponse
encodeRedirectUrl
public java.lang.String encodeRedirectUrl(java.lang.String url)
- Deprecated. As of version 2.1, use
encodeRedirectURL(String url) instead
- Specified by:
encodeRedirectUrlin interfacejavax.servlet.http.HttpServletResponse
sendError
public void sendError(int status,
java.lang.String message)
throws java.io.IOException
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sends an error response to the client using the specified
status. The server defaults to creating the
response to look like an HTML-formatted server error page
containing the specified message, setting the content type
to "text/html", leaving cookies and other headers unmodified.
If an error-page declaration has been made for the web application
corresponding to the status code passed in, it will be served back in
preference to the suggested msg parameter.
If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.
- Specified by:
sendErrorin interfacejavax.servlet.http.HttpServletResponse
sendError
public void sendError(int status)
throws java.io.IOException
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sends an error response to the client using the specified status
code and clearing the buffer.
If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.
- Specified by:
sendErrorin interfacejavax.servlet.http.HttpServletResponse
sendRedirect
public void sendRedirect(java.lang.String url) throws java.io.IOException
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sends a temporary redirect response to the client using the
specified redirect location URL. This method can accept relative URLs;
the servlet container must convert the relative URL to an absolute URL
before sending the response to the client. If the location is relative
without a leading '/' the container interprets it as relative to
the current request URI. If the location is relative with a leading
'/' the container interprets it as relative to the servlet container root.
If the response has already been committed, this method throws an IllegalStateException. After using this method, the response should be considered to be committed and should not be written to.
- Specified by:
sendRedirectin interfacejavax.servlet.http.HttpServletResponse
setDateHeader
public void setDateHeader(java.lang.String name, long value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sets a response header with the given name and
date-value. The date is specified in terms of
milliseconds since the epoch. If the header had already
been set, the new value overwrites the previous one. The
containsHeadermethod can be used to test for the presence of a header before setting its value.- Specified by:
setDateHeaderin interfacejavax.servlet.http.HttpServletResponse
setHeader
public void setHeader(java.lang.String name, java.lang.String value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sets a response header with the given name and value.
If the header had already been set, the new value overwrites the
previous one. The
containsHeadermethod can be used to test for the presence of a header before setting its value.- Specified by:
setHeaderin interfacejavax.servlet.http.HttpServletResponse
setIntHeader
public void setIntHeader(java.lang.String name, int value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sets a response header with the given name and
integer value. If the header had already been set, the new value
overwrites the previous one. The
containsHeadermethod can be used to test for the presence of a header before setting its value.- Specified by:
setIntHeaderin interfacejavax.servlet.http.HttpServletResponse
addDateHeader
public void addDateHeader(java.lang.String name, long value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Adds a response header with the given name and
date-value. The date is specified in terms of
milliseconds since the epoch. This method allows response headers
to have multiple values.
- Specified by:
addDateHeaderin interfacejavax.servlet.http.HttpServletResponse
addHeader
public void addHeader(java.lang.String name, java.lang.String value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Adds a response header with the given name and value.
This method allows response headers to have multiple values.
- Specified by:
addHeaderin interfacejavax.servlet.http.HttpServletResponse
addIntHeader
public void addIntHeader(java.lang.String name, int value)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Adds a response header with the given name and
integer value. This method allows response headers to have multiple
values.
- Specified by:
addIntHeaderin interfacejavax.servlet.http.HttpServletResponse
setStatus
public void setStatus(int status)
- Description copied from interface:
javax.servlet.http.HttpServletResponse - Sets the status code for this response. This method is used to
set the return status code when there is no error (for example,
for the status codes SC_OK or SC_MOVED_TEMPORARILY). If there
is an error, and the caller wishes to invoke an error-page defined
in the web application, the
sendErrormethod should be used instead.The container clears the buffer and sets the Location header, preserving cookies and other headers.
- Specified by:
setStatusin interfacejavax.servlet.http.HttpServletResponse
setStatus
public void setStatus(int status,
java.lang.String message)
- Deprecated. As of version 2.1 of the Servlet spec.
To set a status code
use
setStatus(int), to send an error with a description usesendError(int, String). Sets the status code and message for this response.- Specified by:
setStatusin interfacejavax.servlet.http.HttpServletResponse
getOutputStream
public javax.servlet.ServletOutputStream getOutputStream()
- Description copied from interface:
javax.servlet.ServletResponse - Returns a javax.servlet.ServletOutputStream suitable for writing binary
data in the response. The servlet container does not encode the
binary data.
Calling flush() on the ServletOutputStream commits the response. Either this method or ServletResponse.getWriter()>
ServletResponse.getWriter()55 may be called to write the body, not both.- Specified by:
getOutputStreamin interfacejavax.servlet.ServletResponse
getWriter
public java.io.PrintWriter getWriter() throws java.io.IOException
- Description copied from interface:
javax.servlet.ServletResponse - Returns a
PrintWriterobject that can send character text to the client. ThePrintWriteruses the character encoding returned by ServletResponse.getCharacterEncoding()>ServletResponse.getCharacterEncoding()55 . If the response's character encoding has not been specified as described ingetCharacterEncoding(i.e., the method just returns the default valueISO-8859-1),getWriterupdates it toISO-8859-1.Calling flush() on the
PrintWritercommits the response.Either this method or ServletResponse.getOutputStream()>
ServletResponse.getOutputStream()55 may be called to write the body, not both.- Specified by:
getWriterin interfacejavax.servlet.ServletResponse
setContentLength
public void setContentLength(int len)
- Description copied from interface:
javax.servlet.ServletResponse - Sets the length of the content body in the response
In HTTP servlets, this method sets the HTTP Content-Length header.
- Specified by:
setContentLengthin interfacejavax.servlet.ServletResponse
getContentType
public java.lang.String getContentType()
- Description copied from interface:
javax.servlet.ServletResponse - Returns the content type used for the MIME body
sent in this response. The content type proper must
have been specified using ServletResponse.setContentType(java.lang.String)>
ServletResponse.setContentType(java.lang.String)55 before the response is committed. If no content type has been specified, this method returns null. If a content type has been specified and a character encoding has been explicitly or implicitly specified as described in ServletResponse.getCharacterEncoding()>ServletResponse.getCharacterEncoding()55 , the charset parameter is included in the string returned. If no character encoding has been specified, the charset parameter is omitted.- Specified by:
getContentTypein interfacejavax.servlet.ServletResponse
setContentType
public void setContentType(java.lang.String contentType)
- Description copied from interface:
javax.servlet.ServletResponse - Sets the content type of the response being sent to
the client, if the response has not been committed yet.
The given content type may include a character encoding
specification, for example,
text/html;charset=UTF-8. The response's character encoding is only set from the given content type if this method is called beforegetWriteris called.This method may be called repeatedly to change content type and character encoding. This method has no effect if called after the response has been committed. It does not set the response's character encoding if it is called after
getWriterhas been called or after the response has been committed.Containers must communicate the content type and the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the
Content-Typeheader is used.- Specified by:
setContentTypein interfacejavax.servlet.ServletResponse
setCharacterEncoding
public void setCharacterEncoding(java.lang.String encoding)
- Description copied from interface:
javax.servlet.ServletResponse - Sets the character encoding (MIME charset) of the response
being sent to the client, for example, to UTF-8.
If the character encoding has already been set by
ServletResponse.setContentType(java.lang.String)>
ServletResponse.setContentType(java.lang.String)55 or ServletResponse.setLocale(java.util.Locale)>ServletResponse.setLocale(java.util.Locale)55 , this method overrides it. Calling ServletResponse.setContentType(java.lang.String)>ServletResponse.setContentType(java.lang.String)55 with theStringoftext/htmland calling this method with theStringofUTF-8is equivalent with callingsetContentTypewith theStringoftext/html; charset=UTF-8.This method can be called repeatedly to change the character encoding. This method has no effect if it is called after
getWriterhas been called or after the response has been committed.Containers must communicate the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the character encoding is communicated as part of the
Content-Typeheader for text media types. Note that the character encoding cannot be communicated via HTTP headers if the servlet does not specify a content type; however, it is still used to encode text written via the servlet response's writer.- Specified by:
setCharacterEncodingin interfacejavax.servlet.ServletResponse
getCharacterEncoding
public java.lang.String getCharacterEncoding()
- Description copied from interface:
javax.servlet.ServletResponse - Returns the name of the character encoding (MIME charset)
used for the body sent in this response.
The character encoding may have been specified explicitly
using the ServletResponse.setCharacterEncoding(java.lang.String)>
ServletResponse.setCharacterEncoding(java.lang.String)55 or ServletResponse.setContentType(java.lang.String)>ServletResponse.setContentType(java.lang.String)55 methods, or implicitly using the ServletResponse.setLocale(java.util.Locale)>ServletResponse.setLocale(java.util.Locale)55 method. Explicit specifications take precedence over implicit specifications. Calls made to these methods aftergetWriterhas been called or after the response has been committed have no effect on the character encoding. If no character encoding has been specified,ISO-8859-1is returned.See RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt) for more information about character encoding and MIME.
- Specified by:
getCharacterEncodingin interfacejavax.servlet.ServletResponse
toString
public java.lang.String toString()
- Description copied from class:
java.lang.Object - Convert this Object to a human-readable String.
There are no limits placed on how long this String
should be or what it should contain. We suggest you
make it as intuitive as possible to be able to place
it into System.out.println() 55
and such.
It is typical, but not required, to ensure that this method never completes abruptly with a java.lang.RuntimeException.
This method will be called when performing string concatenation with this object. If the result is
null, string concatenation will instead use"null".The default implementation returns
getClass().getName() + "@" + Integer.toHexString(hashCode()).
unwrap
public static ServletHttpResponse unwrap(javax.servlet.ServletResponse response)
- Unwrap a ServletResponse.
|
|||||||||
| Home >> All >> org >> mortbay >> jetty >> [ servlet overview ] | PREV CLASS NEXT CLASS | ||||||||
SUMMARY: JAVADOC | SOURCE | DOWNLOAD | NESTED | FIELD | CONSTR | METHOD |
DETAIL: FIELD | CONSTR | METHOD | ||||||||
JAVADOC
org.mortbay.jetty.servlet.ServletHttpResponse